function [Rp_KK]=KKTransformfilter(f,Re_z,Im_z,filter)
% [Rp_KK]=KKTransform(f,Re_z,Im_z)
% Usage: Solves the KKT for the GP
% Created by: Yehu-David Horev
% Re_wrote_for_speed: yehoyachin josef the third
%--------------------------------------------------------------------------
Re_z=Re_z(:);
Im_z=Im_z(:);
f=f(:);
w1=2*pi*f; 
a=1;
w=eval(['w',num2str(a)]);
i=sqrt(-1);
Z=Re_z-i*Im_z;
ReZ=Re_z;
ImZ=Im_z;
index=length(w);
% Real from imaginary part %
ReKK=zeros(index,1); 
for m=1:index
    for k=1:index
        if k~=m
            RKK(k)=(w(k)*imag(Z(k))-w(m)*imag(Z(m)))/((w(k))^2-w(m)^2); 
        end
        if k==m && k~=1 && k~=index
            RKK(k)=0.5*(imag(Z(k))/w(k)+((imag(Z(k+1))-imag(Z(k-1)))/(w(k+1)-w(k-1))));
        end
        if k==m && k==1 && k~=index
            RKK(k)=0.5*(imag(Z(k))/w(k)+((imag(Z(k+1))-imag(Z(k)))/(w(k+1)-w(k)))); 
        end
        if k==m && k~=1 && k==index
            RKK(k)=0.5*(imag(Z(k))/w(k)+((imag(Z(k))-imag(Z(k-1)))/(w(k)-w(k-1)))); 
        end
    end

    [pp,p]=csaps(w,RKK);
    Re_KK1=diff(fnval(fnint(pp),[w(1) w(end)]));

    RKK=RKK(:);
    ReKK=0;
    trap=0; 
    dw=0; 
    for mm=1:index-1
        trap=(RKK(mm+1)+RKK(mm))/2;
        dw=w(mm+1)-w(mm);
        ReKK=ReKK+trap*dw;
    end
    Real_KK(m)=(2/pi)*ReKK+Re_z(end);  
    Real_KK1(m)=(2/pi)*Re_KK1+Re_z(end); 
end

% Imaginary from Real part
ImKK=zeros(index,1); 
tic
for m=1:index
    for k=1:index
        if k~=m
            IKK(k)=(real(Z(k))-real(Z(m)))/((w(k))^2-w(m)^2); 
        end
        if k==m && k~=1 && k~=index
            IKK(k)=(((real(Z(k+1))-real(Z(k-1)))/(w(k+1)-w(k-1))))/(2*w(k)); 
        end
        if k==m && k==1 && k~=index
            IKK(k)=(((real(Z(k+1))-real(Z(k)))/(w(k+1)-w(k))))/(2*w(k)); 
        end
        if k==m && k~=1 && k==index
            IKK(k)=((real(Z(k))-real(Z(k-1)))/(w(k)-w(k-1)))/(2*w(k)); 
        end
    end

    [pp,p]=csaps(w,IKK); 
    Im_KK1=diff(fnval(fnint(pp),[w(1),w(end)]));

    ImKK=0;
    trap=0;
    dw=0; 
    for mm=1:index-1
        trap=(IKK(mm+1)+IKK(mm))/2;
        dw=w(mm+1)-w(mm);
        ImKK=ImKK+trap*dw;
    end
    Imag_KK(m)=(2*w(m)/pi)*(ImKK); 
    Imag_KK1(m)=(2*w(m)/pi)*(Im_KK1); 
end
toc

% Accuracy of calculations
Im_ex_max=max(abs(imag(Z)));
Re_ex_max=max(abs(real(Z)));
AER=(100/Re_ex_max/index)*sum(abs(ReZ(:)-Real_KK(:))); 
AEI=(100/Im_ex_max/index)*sum(abs(ImZ(:)-Imag_KK(:))); 
AER1=(100/(Re_ex_max*index))*sum(abs(ReZ(:)-Real_KK1(:))); 
AEI1=(100/(Im_ex_max*index))*sum(abs(ImZ(:)-Imag_KK1(:))); 

% Polarization Resistance indirect calculations
RpKK=imag(Z)./w;
Rp_KK=0;
trap=0;
dw=0;
for mm=1:index-1
    trap=(RpKK(mm+1)+RpKK(mm))/2;
    dw=w(mm+1)-w(mm);
    Rp_KK=Rp_KK+trap*dw;
end
Rp_KK=(2/pi)*Rp_KK;

% Polarization Resistance direct calculation
Rpd=real(Z(1))-real(Z(end));
AERp=abs(abs(Rp_KK)-abs(Rpd))/abs(Rpd)*100; 
save data_kkt.mat

% R^2 calculation
SSR_Re=sum((Real_KK1-mean(Re_z)).^2); 
SSR_Im=sum((Imag_KK1-mean(Im_z)).^2); 
SSE_Re=sum((Real_KK1(:)-Re_z(:)).^2); 
SSE_Im=sum((Imag_KK1(:)-Im_z(:)).^2); 
SST_Re=sum((Re_z-mean(Re_z)).^2); 
SST_Im=sum((Im_z-mean(Im_z)).^2); 
%load_plot_kkt