function out=K(a,x,gamma1,gamma2)
% out=K(a,x,gamma1,gamma2)
% Usage: Asymmetric Lorenz
%        a = height
%        x = log10(tau)--> vector
%        gamma1,gamma2 = width        
% Created by: Yehu-David Horev
%--------------------------------------------------------------------------
% this is used in case the parameter of tau0 is out of the tau vector border
flag=length(x);
% search for the changing of width point
for i=2:length(x)
    % in case tau0 is in border here the swap is taking place
    if sign(x(i))~=sign(x(i-1))
        % changing the flag indicator of place in tau vector
        flag=i;
        break
    end
end
% sending the 1st part of the func & making it a column vector
out1=L(a,x(1:flag),gamma1);
out1=out1(:);
% sending the 2nd part of the func & making it a column vector
out2=L(a,x(flag+1:end),gamma2);
out2=out2(:);
% sending the result out as a column vector
out=[out1;out2];