function Outpicks(varargin)
% ForcedPick(varargin)
% Usage: User can choose to force a certain pick in a particular range
% Written by: Maor Asher
% Modified by: Arthur Doroshev
%--------------------------------------------------------------------------
global comm par
if nargin==0
    % Set Default values:
    comm.pos=[240,227,800,550];
    comm.dirname='0';
    comm.existingfile='';
    comm.name='';
    comm.ramp(1:2,1:5)=-1;
    comm.movie=0;
    comm.plot=0;
    comm.UseFilter=0;
    comm.LoadParamaters=0;
    comm.path1='';
    comm.path2='';
    comm.spath1='';
    comm.spath2='';
else
    comm=varargin{1};
end

%par=load([comm.dirname,'\','par.mat']);
outpicks=figure('Position',[350,350,400,250],'Color','White','MenuBar','none','NumberTitle','off','Name','Impedance Spectroscopy Genetic Programming','Resize','off','Tag','outpicks');
if nargin==0
    movegui(outpicks,'center')
end
handles=guihandles;
guidata(outpicks,handles);

%------------ Buttons: ------------%
inimutpnl=uipanel('Title','Out of Range Peaks','FontSize',10,'Parent',handles.outpicks,'Units','pixels','Position',[5,5,395,245],'BackgroundColor','White');

% Help:
handles.help=uicontrol('Style','pushbutton','Units','pixels','Position',[10,10,70,25],'FontWeight','bold','String','Help');

% OK:
handles.OK=uicontrol('Style','pushbutton','Units','pixels','Position',[220,10,70,25],'FontWeight','bold','Enable','on','String','OK');

% Cancle:
handles.Cancle=uicontrol('Style','pushbutton','Units','pixels','Position',[140,10,70,25],'FontWeight','bold','String','Cancle');

%------------ text: ------------%
% text: "initial":
handles.initial.txt=uicontrol('Style','text','Units','pixels','Position',[175,190,50,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','initial');

% text: "mutation":
handles.mutation.txt=uicontrol('Style','text','Units','pixels','Position',[235,190,70,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','mutation');

% text: "lb":
handles.lb.txt=uicontrol('Style','text','Units','pixels','Position',[310,190,30,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','lb');

% text: "ub":
handles.ub.txt=uicontrol('Style','text','Units','pixels','Position',[350,190,30,20],'BackgroundColor','White','FontSize',10,'FontWeight','bold','HorizontalAlignment','center','Parent',inimutpnl,'String','ub');


%------------ picks ------------%
% The function Y used to be Called R
% R - Low Tau Gaussian:
handles.R.txt=uicontrol('Style','text','BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','pos',[5,145,150,30],'Tag','R','Parent',inimutpnl,'HandleVisibility','off','String','Y - Low Tau Pseudo-Delta');
handles.R.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[190,155,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.R.initial,'String','');
handles.R.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[260,155,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.R.mutation,'String','');
handles.R.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[310,155,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.R.lb));
handles.R.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[350,155,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.R.ub));

if get(handles.R.initial,'Value')+get(handles.R.mutation,'Value')>0
    set(handles.R.txt,'FontWeight','bold');
    set(handles.R.lb,'Enable','on');
    set(handles.R.ub,'Enable','on');
end

% U - Low Tau Gaussian:
handles.U.txt=uicontrol('Style','text','BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','pos',[5,80,150,30],'Tag','R','Parent',inimutpnl,'HandleVisibility','off','String','U - High Tau Pseudo-Delta');
handles.U.initial=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[190,90,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.U.initial,'String','');
handles.U.mutation=uicontrol('Style','checkbox','Units','pixels','Parent',inimutpnl,'Position',[260,90,80,20],'BackgroundColor','White','FontSize',10,'Max',1,'Min',0,'Value',par.U.mutation,'String','');
handles.U.lb=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[310,90,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.U.lb));
handles.U.ub=uicontrol('Style','edit','Units','pixels','Parent',inimutpnl,'Enable','off','Position',[350,90,30,20],'BackgroundColor','White','FontSize',10,'HorizontalAlignment','center','String',num2str(par.U.ub));

if get(handles.U.initial,'Value')+get(handles.U.mutation,'Value')>0
    set(handles.U.txt,'FontWeight','bold');
    set(handles.U.lb,'Enable','on');
    set(handles.U.ub,'Enable','on');
end

% PB Callback:
set(handles.OK,'CallBack',{@PBOK,handles});
set(handles.Cancle,'CallBack',{@PBCancle,handles});
set(handles.help,'CallBack',{@PBHelp,handles});

% Picks Callback:
set(handles.R.initial,'CallBack',{@R_check,handles});
set(handles.R.mutation,'CallBack',{@R_check,handles});
set(handles.U.initial,'CallBack',{@U_check,handles});
set(handles.U.mutation,'CallBack',{@U_check,handles});

%------------ Functions: ------------%
% Create
%function CreateFunction()
%clc

% Cancle Button:
function PBCancle(hObject,eventdata,handles)
delete(handles.outpicks);

% Help Button:
function PBHelp(hObject,eventdata,handles) 
web http://electroceramics.technion.ac.il/isgp/help.html

% Ok Button:
function PBOK(hObject,eventdata,handles) 
global par comm
par.R.initial=get(handles.R.initial,'Value');
par.U.initial=get(handles.U.initial,'Value');

par.R.mutation=get(handles.R.mutation,'Value');
par.U.mutation=get(handles.U.mutation,'Value');

par.R.lb=str2double(get(handles.R.lb,'String'));
par.U.lb=str2double(get(handles.U.lb,'String'));

par.R.ub=str2double(get(handles.R.ub,'String'));
par.U.ub=str2double(get(handles.U.ub,'String'));

% conditions:
if isnan(par.R.lb) || isinf(par.R.lb)
    errordlg('Lower bound must be a number','error','modal');
    return
end

if isnan(par.R.ub) || isinf(par.R.ub)
    errordlg('Upper bound must be a number','error','modal');
    return
end

if isnan(par.U.lb) || isinf(par.U.lb)
    errordlg('Lower bound must be a number','error','modal');
    return
end

if isnan(par.U.ub) || isinf(par.U.ub)
    errordlg('Upper bound must be a number','error','modal');
    return
end

if  par.R.lb<-20
    errordlg('Lower bound must be above -20','error','modal');
    return
end

if  par.R.ub>20
    errordlg('Upper bound must be below 20','error','modal');
    return
end

if  par.R.ub<par.R.lb
    errordlg('Upper bound must be bigger the its lower bound','error','modal');
    return
end

if  par.U.lb<-20
    errordlg('Lower bound must be above -20','error','modal');
    return
end

if  par.U.ub>20
    errordlg('Upper bound must be below 20','error','modal');
    return
end

if  par.U.ub<par.U.lb
    errordlg('Upper bound must be bigger the its lower bound','error','modal');
    return
end

% save par and delete screen!
save([comm.dirname,'\','par.mat'],'-struct','par');
delete(handles.outpicks)

% R - Low Tau Gauss Function:
function R_check(hObject,eventdata,handles) 
if get(handles.R.initial,'Value') || get(handles.R.mutation,'Value')
    set(handles.R.txt,'FontWeight','bold');
    set(handles.R.lb,'Enable','on');
    set(handles.R.ub,'Enable','on');
else
    set(handles.R.txt,'FontWeight','normal');
    set(handles.R.lb,'Enable','off');
    set(handles.R.ub,'Enable','off');
end

% U - High Tau Gauss Function:
function U_check(hObject,eventdata,handles)
if get(handles.U.initial,'Value') || get(handles.U.mutation,'Value')
    set(handles.U.txt,'FontWeight','bold');
    set(handles.U.lb,'Enable','on');
    set(handles.U.ub,'Enable','on');
else
    set(handles.U.txt,'FontWeight','normal');
    set(handles.U.lb,'Enable','off');
    set(handles.U.ub,'Enable','off');
end