function sigmot=Pickswidth(pop)
% sigmot=Pickswidth(pop)
% Usage: Calculate the width of the model's picks
% Modified by: Maor Asher, Arthur Doroshev
%--------------------------------------------------------------------------
global data
counter=0;
sigmot=[];
a='';
b='';
tau=1./(2.*pi.*data(:,1));
d_width=0.4911*log10(max(tau)/min(tau))/length(tau);

for i=1:length(pop)
    % 2 free parameters
    if pop(i)=='D'     || pop(i)=='Y'    || pop(i)=='U'
        % Pseudo Delta || high tau Delta || low tau Delta
        sigmot=[sigmot,d_width];
        %sigmot=[sigmot,2*hh]; 
        
    % 3 free parameters
    elseif pop(i)=='G' || pop(i)=='L' || pop(i)=='S' || pop(i)=='C' || pop(i)=='B' 
        % Gaussian     || Lorentzian  || Sech        || Cole-Cole   || Kirkwood Fous
        while counter<3
            i=i+1; 
            if pop(i)=='['
                counter=counter+1;
            end
        end
        i=i+1;
        while pop(i)~=']'
            a=strcat(a,pop(i));
            i=i+1; 
        end
        sigmot=[sigmot,str2double(a)];
        
     % 4 free parameters
    elseif pop(i)=='F'        || pop(i)=='K'           || pop(i)=='E'     || pop(i)=='A' || pop(i)=='P' || pop(i)=='H' 
        % Asymmetric Gaussian || Asymmetric Lorentzian || Asymmetric Sech || Losev       || Pearson VII || Havriliak Negami 
        while counter<3
            i=i+1; 
            if pop(i)=='['
                counter=counter+1;
            end
        end
        i=i+1; 
        while pop(i)~=']'
            a=strcat(a,pop(i));
            i=i+1; 
        end
        sigmot=[sigmot,str2double(a)]; 
        i=i+3; 
        while pop(i)~=']'
            b=strcat(b,pop(i));
            i=i+1; 
        end
        sigmot=[sigmot,str2double(b)];
        
     % 5 free parameters
    elseif pop(i)=='V'
        % Pseudo Voigt
        while counter<3
            i=i+1; 
            if pop(i)=='['
            counter=counter+1;
            end
        end
        i=i+1; 
        while pop(i)~=']'
            a=strcat(a,pop(i));
            i=i+1; 
        end
        sigmot=[sigmot,str2double(a)];
        i=i+3; 
        while pop(i)~=']'
            b=strcat(b,pop(i));
            i=i+1; 
        end
        sigmot=[sigmot,str2double(b)]; 
    end
    
    counter=0;
    a='';
    b='';
end