function [y_r,yi]=int_simpson_matrix(model,u,hh)
% [y_r,yi]=int_simpson_matrix(model,u,ym),
% Usage: Calculating the convolution for a model
%           model = evaluated model in the temporal
%           u = log10(tau)
%           hh= point diff. factor
% Written by: Alex Tesler
% Modified by: Yehu-David Horev, Maor Asher
%--------------------------------------------------------------------------
% renaming vector and transforming it into omega
log10tau=u;
tau=10.^log10tau;
w=1./tau;
tt=(-20:hh:20); 
% calculation by alex tesler
nnk=length(log10tau);
nnt=length(tt);
Imp1=zeros(nnt,nnk); 
j=sqrt(-1);
ker=1./(1+j.*((10.^tt)'*w'));
[row,column]=size(model);
if row==1 && column==1
    model=ones(1,nnt)*model;
    m1=model*ones(1,nnk);
else
    m1=model*ones(1,nnk);
end
kg=ker.*m1;

c=ones(nnt,1);
c(2:2:nnt-1)=4;
c(3:2:nnt-1)=2;
c=c*hh/3;
Imp1=kg'*c;

yi=-imag(Imp1);
yi=yi(:);
y_r=real(Imp1);
y_r=y_r(:);