function [pop_swap]=swappick(pop,mut_fun_set)
% [pop_swap]=swappick(pop,mut_fun_set)
% Usage: Swaps a random peak to the gene.
%        pop = the string(gene) evolving
%        mut_fun_set = the bank of peaks can be used
% Written by: Yehu-David Horev
%--------------------------------------------------------------------------
% choose random peak from the mutation bank
% "ceil" makes the calculation result as a whole number => 0.7=>1
% "rand" chooses a number in random from 0 to 1
sp=ceil(rand(1)*length(mut_fun_set));
% choose random position in the gene where the peak will be added
% "ceil" makes the calculation result as a whole number => 0.7=>1
% "rand" chooses a number in random from 0 to 1
ind=ceil(rand(1)*length(pop));
% add the peak
pop_swap=[pop(1:ind-1),mut_fun_set(sp),pop(ind+1:end)];